<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of actions
 *
 * @author Manuel Enrique Paredes Lopez
 */
class ca_log_webActions extends sfQuery {
    
    protected $table_names = array(
        'WEBSERVICES_LOG'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'WEBSERVICES_LOG' =>
        array(
            'id' => 'id',
            'usuario' => 'usuario',
            'cliente' => 'cliente',
            'servicio' => 'servicio',
            'fecha_log_ini' => 'fecha_log_ini',
            'fecha_log_fin' => 'fecha_log_fin',
            'parametros' => 'parametros',
            'respuesta' => 'respuesta',
            'termino_proceso' => 'termino_proceso',
            'motivo_error' => 'motivo_error' 
        )
    );
    
     /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * BETWEENFECHA - para filtrar entre fechas y no tener encuenta la hora - ejemplo: where to_char(campo, 'YYYY-MM-DD') between x and y
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'WEBSERVICES_LOG' =>
        array('usuario' => array('LIKEALLPLUS' => array('usuario')),
            'cliente' => array('LIKEALLPLUS' => array('cliente')),
            'servicio' => array('LIKEALLPLUS' => array('servicio')),
            'fecha_log_ini' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'termino_proceso' => array('=' => array('termino_proceso')),
            'motivo_error' => array('LIKEALLPLUS' => array('motivo_error'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(  ); // filtros de condicion or
    
    
    
    
    // filtros de condicion or
    protected $fields_orderBy = array(
        'id'
    ); //campos para el ordenamiento de la consulta

    /*
     * Variables manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    //false - Registrar log para list - consultar
    protected $log_list = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;
    
    //put your code here
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {
        
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
        
    }

    protected function preprocessRequest($Action, sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
        
    }

    protected function validateAdd(sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
        
    }

    protected function validateRemove(sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
        
    }

    protected function validateUpdate(sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
        
    }

}
